//functions abstracted from our core Data requests
//these are platform-dependent portions of code which
// set incoming data into their respective UI elements
// ...the WU Data parts are platform-independent

//bool which tells us to display or not to display the alert on show/hides
var alert_displayed = false;

function setAlert(alerts) {
	var url = prefs.get("niceUrl");
	
	var alBackground = document.getElementById('DockedBottom_alertBackground');
	var alMessage = document.getElementById('DockedBottom_alertMessage');
	alMessage.onclick = null;
	
	var only_non_crucial = true;
	var alert_string = "";
	var critical_type = '';
	
  var sortBySeverity = function(a,b) {
    var types = ["HUR","TOR","TOW","WRN","SEW","FLO","WIN","WAT","WND","SVR","HEA","FOG","THU","FIR","VOL","SPE","REC","REP","PUB"];
    var aIndex = 18; var bIndex = 18;
    for (var i = 0; i < 19; i++) {
      if (types[i] == a.type) aIndex = i;
      if (types[i] == b.type) bIndex = i;
    }
    if (aIndex == bIndex) return 0;
    return (aIndex < bIndex ? -1 : 1);
  };
  
  alerts.sort(sortBySeverity);
  
  for(var i = 0; i < alerts.length; i++) {
	  al = alerts[i];
	  if (al.type != "REP" && al.type != "PUB" && al.type != "REC") {
	    only_non_crucial = false; critical_type = al.type;
	  }
	  alert_string += (al.type == "PUB" ? getLocalizedString("Public Statement") : getLocalizedString(al.description)) + (i < alerts.length - 1 ? " &amp; ":"");
	}


	
	//not crucial information
	if (only_non_crucial == true && (alerts.length > 0 || Gadget_upgradeAlert != null)) {
		alBackground.src = "Images/alertBlue.png";
    if (Gadget_upgradeAlert != null) {alert_string += Gadget_upgradeAlert.description;}
		alMessage.innerHTML = alert_string;
		alMessage.style.color = "#222";
		setAlertDisplay("");
		alert_displayed = true;
		
		if (Gadget_upgradeAlert != null) {
		  alMessage.onclick = linkTo(Gadget_upgradeAlert.url);
		} else {
  		alMessage.onclick = linkTo("http://www.wunderground.com" + url + "#" + (critical_type || alerts[0].type));  
		}
		
	} else if (alerts.length > 0) {
		alBackground.src = "Images/alertRed.png";
		alMessage.innerHTML = alert_string;
		alMessage.style.color = "#fff";
		setAlertDisplay("");
		alert_displayed = true;
		
		alMessage.onclick = linkTo("http://www.wunderground.com" + url + "#" + (critical_type || alerts[0].type));
	} else {
		alert_displayed = false;
		setAlertDisplay('none');
	}
}

function setAlertDisplay(display) {
	var alertMessage = document.getElementById('DockedBottom_alertMessage');
	alertMessage.style.display = display;
	var alertBackground = document.getElementById('DockedBottom_alertBackground');
	alertBackground.style.display = display;
}

function setForecast(fcst) {
	var url = prefs.get("niceUrl");

	//WEEK FORECAST
	var len = fcst.weekFcsts.length; var times;
	var unit;

  $('DockedTop_location').onclick = linkTo("http://www.wunderground.com" + url);
  $('DockedTop_temperature').onclick = linkTo("http://www.wunderground.com" + url);
  
	for(var i = 0; i < len && i < 3; i++) {
		document.getElementById('day'+i).innerHTML = weekDay(fcst.weekFcsts[i].day);
		document.getElementById('day'+i).innerHTML = document.getElementById('day'+i).innerHTML.toUpperCase();
    document.getElementById('day'+i).onclick = linkTo("http://www.wunderground.com" + url);
    
		document.getElementById('high'+i).innerHTML = unitData(fcst.weekFcsts[i].high,"bigTemp");
		document.getElementById('low'+i).innerHTML = unitData(fcst.weekFcsts[i].low,"bigTemp");
		
		var pic = document.getElementById('pic'+i);
		pic.src = "Images/icons/"+(fcst.weekFcsts[i].icon ? fcst.weekFcsts[i].icon: "blank") + ".png";
    pic.alt = getLocalizedString(toCapitalCase(fcst.weekFcsts[i].conditions));
    pic.title = getLocalizedString(toCapitalCase(fcst.weekFcsts[i].conditions));
    pic.onclick = linkTo("http://www.wunderground.com" + url);
	}	
	
	if (len > 0) {
    // fcst.weekFcsts[0].high 
		document.getElementById('DockedTop_todaysHighAndLow').innerHTML = unitData(fcst.weekFcsts[0].high,"bigTemp") + ' - '+ unitData(fcst.weekFcsts[0].low,"bigTemp");
	}

  //If we aren't stretched, hide the pictures again
  if (prefs.get("isStretched") === false) {
    Stretch_setPics('hidden');
  }
  
	var oldNightOrDay = Weather_NightOrDay;
	var tempNightOrDay = Gadget_determineNightOrDay(fcst.moon);
	if (Weather_NightOrDay != tempNightOrDay) {
	  Weather_NightOrDay = tempNightOrDay;
	  Gadget_loadBackgrounds();
	}
}

function setCurConds (cur_conds, no_overwrite, type) {
	var windchill;
	var heatindex;
	var wind;
	var temp;
	var dewpoint;
	var visibility;	
	var pressure;

  debug.trace("setCurConds_type: "+type);
  if (type == 'airport') {
  	if (cur_conds.icon != null && typeof(Forecast_forecastData) != "undefined" && Forecast_forecastData != null) {//so PWS cur conds don't overwrite our airport icon conditions
  	  debug.trace("cur_cond: "+cur_conds.icon);
      debug.trace('airport NO overwrite bg');
      Gadget_changeBackgroundHeaderWithCondition(cur_conds.icon);
  	} else if (no_overwrite == false) {
  	  debug.trace('airport overwrite bg');
      Gadget_changeBackgroundHeaderWithCondition('unknown');
  	}
  	//add information for toolTip conditions
    $('DockedTop').alt = $('DockedTop').title = getLocalizedString(toCapitalCase(cur_conds.conditions_full));
  }


	//only run if we don't care about overwriting conditions already on the widget
	if (no_overwrite == false) {  
    $('DockedTop_temperature').innerHTML = (unitData(cur_conds.temperature,"bigTemp") != "N/A" ? unitData(cur_conds.temperature,"bigTemp") : "--&deg;");
	}
}