var query;
var view = window; //use so our data functions work universally

var gGadgetMode = (window.System !== undefined); //if we're in gadget mode or dev. mode
var Gadget_VERSION = 1.13;
var Gadget_upgradeAlert;
var Weather_NightOrDay = 'day'; //var used to determine BG set
var loc; //JSON object used to store webcam, radar, and location data. 

var localization = new Localization();

function Gadget_setup() {

	Gadget_loadBackgrounds();
	Gadget_setSettings();
		
	localization.getLANG();
		
  //First time
	if (!prefs.get("url")) {
		
		Gadget_firstLoad();
	
	//already used
	} else {
	  
    if (prefs.get("isStretched") === true) {
      prefs.set("isStretched",false); //set it to what it really is currently and not what was saved
                                      //so the stretch function isn't confused
      Stretch_init(document.getElementById('DockedMiddle'),Stretch_flipImage);
    }
    
		loc = prefs.get("loc");
		
		Gadget_loadLocationNames();
    Forecast_retrieve(Gadget_launchLocalStns, Forecast_errorLoading);
    Alert_retrieve(setAlert, Alert_errorLoading);
    
	}
}

function Gadget_setSettings() {
  if (gGadgetMode == true) {
    System.Gadget.settingsUI = "settings.html";
  }
}

function blankFunction() {}

function Gadget_showExtendedFlyout() {
  if (gGadgetMode == true) {
    if (System.Gadget.Flyout.show == false) {
  			System.Gadget.Flyout.file = "floatingContent.html";
  			System.Gadget.Flyout.show=true;
  			System.Gadget.Flyout.onHide = blankFunction;
  	} else {
  		  System.Gadget.Flyout.show=false;
  	}
  }
}

function Gadget_loadLocationNames() {
  var location = document.getElementById('DockedTop_location');
	location.innerHTML = prefs.get("location");
	location.title = location.alt = prefs.get("subLocation");
}

function Gadget_loadBackgrounds() {
  if (gGadgetMode) {
    
    // Lookup g:background on MSDN to figure out this logic
    //I'm basically creating a composite background from these separate images
    gBackground.removeObjects();
    gBackground.src = "Images/background/"+Weather_NightOrDay+"/BG_header.png";
    gBackground.addImageObject("Images/background/"+Weather_NightOrDay+"/BG_footer.png",0,prefs.get("isStretched") ? 123 : 49);
    
    if (prefs.get("isStretched") == true) {
      gBackground.addImageObject("Images/background/"+Weather_NightOrDay+"/vista/BG_scale_div_bg.png",0,49);
    }
    document.getElementById('DockedMiddle').style.backgroundImage = "url(Images/background/"+Weather_NightOrDay+"/vista/BG_middle.png)";
    document.getElementById('DockedBottom').style.backgroundImage = "url(Images/background/"+Weather_NightOrDay+"/vista/BG_footer_over.png)";
    
  //don't have to deal with that g:background BS, do it normally
  } else {
    document.getElementById('WeatherGadget').style.backgroundImage = "url(Images/background/"+Weather_NightOrDay+"/BG_header.png)";
    document.getElementById('DockedMiddle').style.backgroundImage = "url(Images/background/"+Weather_NightOrDay+"/BG_middle.png)";
    document.getElementById('DockedBottom').style.backgroundImage = "url(Images/background/"+Weather_NightOrDay+"/BG_footer.png)";
  }
}

// void changeBackgroundHeaderWithCondition ( string condition)
// -- sets the header of the gadget to whatever bg we specify
function Gadget_changeBackgroundHeaderWithCondition(condition) {
  if (gGadgetMode) {
    gBackground.src = "Images/conditions/"+Weather_NightOrDay+"/"+condition+".png";
  } else {
    document.getElementById('WeatherGadget').style.backgroundImage = "url(Images/conditions/"+Weather_NightOrDay+"/"+condition+".png)";    
  }
}

function Gadget_firstLoad() {
	
	//load location and stations variables
	loc = {"city":"San Francisco","state":"CA","country":"US","wuiurl":"http://www.wunderground.com/US/CA/San_Francisco.html","radar":{"image":"http://resize.wunderground.com/cgi-bin/resize_convert?ox=gif&url=radblast/cgi-bin/radar/WUNIDS_composite%3Fcenterlat=37.77500916%26centerlon=-122.41825867%26radius=15%26newmaps=1%26smooth=1%26num=5%26width=130%26height=130&width=130&height=130&time=1186516793","url":"http://www.wunderground.com/radar/radblast.asp?ID=MUX&region=c1&lat=37.77500916&lon=-122.41825867"},"webcams":[{"url":"http://icons.wunderground.com/webcamramdisk/w/u/WunderYakuza/1/widget.jpg?t=1184794680&time=1184794669","camUrl":"http://www.wunderground.com/webcams/WunderYakuza/1/show.html","city":"San Francisco","state":"CA","country":"US","organization":"The Weather Underground","handle":"WunderYakuza"},{"url":"http://icons.wunderground.com/webcamramdisk/a/d/admin/1/widget.jpg?t=1184794680&time=1184794669","camUrl":"http://www.wunderground.com/webcams/admin/1/show.html","city":"San Francisco","state":"CA","country":"US","organization":null,"handle":"admin"},{"url":"http://icons.wunderground.com/webcamramdisk/c/h/Chris/1/widget.jpg?t=1184794680&time=1184794669","camUrl":"http://www.wunderground.com/webcams/Chris/1/show.html","city":"Healdsburg","state":"CA","country":"US","organization":"Weather Underground","handle":"Chris"},{"url":"http://icons.wunderground.com/webcamramdisk/s/f/sfweather/1/widget.jpg?t=1184794680&time=1184794669","camUrl":"http://www.wunderground.com/webcams/sfweather/1/show.html","city":"San Francisco","state":"CA","country":"US","organization":null,"handle":"sfweather"}]};
	prefs.set("loc",loc);
	presetPrefs = { 
	  "selectedWebcam":0,
	  "units":0,
	  "query":"San Francisco, CA",
	  "location":"San Francisco",
	  "subLocation":"China Basin Landing",
	  "PWS":"KCASANFR14",
	  "airport":"KSFO",
	  "floatingContentState":"conditions",
	  "url":"/US/CA/San_Francisco.html",
	  "niceUrl":"/US/CA/San_Francisco.html",
	  "isStretched":false
	};
	for (var p in presetPrefs) {
	  prefs.set(p,presetPrefs[p]);
	}
	
	//after loading forecast, it does a callback to load current conditions
	Forecast_retrieve(Gadget_launchLocalStnsFirstLoad, Forecast_errorLoading);
	Alert_retrieve(setAlert,Alert_errorLoading);
	
}

// void launchLocalStnsFirstLoad ( obj Forecast)
// -- only used on initial run as a callback, sets the forecast and then launches 
function Gadget_launchLocalStnsFirstLoad(forecast) {
	setForecast(forecast);
		
	CurCond_retrieve('airport',true, setCurConds, CurCond_errorLoading);
	CurCond_retrieve('pws',false, setCurConds, CurCond_errorLoading); 
}

// void launchLocalStns ( obj Forecast)
// -- sets the forecast and then launches the current conditions
function Gadget_launchLocalStns(forecast) {
  if (forecast) setForecast(forecast);
	
	var airportId = prefs.get("airport");
	var pwsId = prefs.get("PWS");
	
	if (pwsId && airportId)  {
		CurCond_retrieve('pws',false,setCurConds, CurCond_errorLoading); 
		CurCond_retrieve('airport',true,setCurConds, CurCond_errorLoading); 

	} else if (airportId) {
		CurCond_retrieve('airport',false,setCurConds, CurCond_errorLoading); 

	} else if (pwsId) {
		CurCond_retrieve('pws',false,setCurConds, CurCond_errorLoading); 			
	}
}

function Gadget_setUpgradeDialog(latestVersion,url) {
  Gadget_upgradeAlert = new Object();
  Gadget_upgradeAlert.type = "REP";
  Gadget_upgradeAlert.url = url;
  Gadget_upgradeAlert.description = main.getLocalizedString("New version") + "! <b>Click here</b>";
  Gadget_upgradeAlert.longSummary = "";
}

function Gadget_createLogoLink() {
  addEvent($('logo'),'click',linkTo('http://www.wunderground.com'));
}

addLoadEvent(loadTimeouts);
addLoadEvent(Gadget_setup);
