function getLocalizedString (key)
{
  //EFFECTS: prints out string if contained within our strings variable,
  //otherwise just prints out the regular text
  
	try {
		var ret = localization.strings[key];
		if (ret === undefined)
			ret = key;
		return ret;
	} catch (ex) {}

	return key;
}

function Localization() {
  var self = this;
  
  this.strings = new Array();
  this.isGood = false;
  
  this.getLANG = function() {
    //This AJAX request will automatically load the language of the user
    //based on their browser's settings
    
    var url = "https://www.wunderground.com/stationmaps/language.asp";
    var hasBeenLoaded = false;

    var request = new XMLHttpRequest();
    if (!request) {if (error_loading) {error_loading();} return;}
    request.onreadystatechange = onReadyStateChange;
    request.open("GET", url, true);

    var requestTimeout = view.setTimeout(function() { request.abort(); }, Timeout_TIMEOUT);   

    request.send();

    function onReadyStateChange() {
      if (request.readyState != 4 || hasBeenLoaded == true) {
        return;
      }
      hasBeenLoaded = true;
      view.clearTimeout(requestTimeout);
      if (request.status == 200) {
        
        try {
          //Should load all LANG equivalents into an array
          var LANG;
          eval(request.responseText);
          self.localize_strings(LANG);
          
        } catch(e) {}
        
      } else {
        connection.hasProblem();
      }
    }    
  };
  
  this.localize_strings = function(LANG) {
    //REQUIRES: LANG variable to be present
    //MODIFIES: all strings for use in the getLocalizedString() function,
    //          changes all loocalizable text on the widget as well
    //EFFECT: localizes strings based on kLang equivalents received from Wunderground.
    
    //Days of the week
    self.strings["SUN"] = LANG["kLangSundayAbrev"];
    self.strings["MON"] = LANG["kLangMondayAbrev"];
    self.strings["TUE"] = LANG["kLangTuesdayAbrev"];
    self.strings["WED"] = LANG["kLangWednesdayAbrev"];
    self.strings["THU"] = LANG["kLangThursdayAbrev"];
    self.strings["FRI"] = LANG["kLangFridayAbrev"];
    self.strings["SAT"] = LANG["kLangSaturdayAbrev"];

    //Directions
    self.strings["E"] = LANG["kLang.Direction.E"];
    self.strings["East"] = LANG["kLang.Direction.East"];
    self.strings["ENE"] = LANG["kLang.Direction.ENE"];
    self.strings["ESE"] = LANG["kLang.Direction.ESE"];
    self.strings["N"] = LANG["kLang.Direction.N"];
    self.strings["NE"] = LANG["kLang.Direction.NE"];
    self.strings["NNE"] = LANG["kLang.Direction.NNE"];
    self.strings["NNW"] = LANG["kLang.Direction.NNW"];
    self.strings["North"] = LANG["kLang.Direction.North"];
    self.strings["NW"] = LANG["kLang.Direction.NW"];
    self.strings["S"] = LANG["kLang.Direction.S"];
    self.strings["SE"] = LANG["kLang.Direction.SE"];
    self.strings["South"] = LANG["kLang.Direction.South"];
    self.strings["SSE"] = LANG["kLang.Direction.SSE"];
    self.strings["SSW"] = LANG["kLang.Direction.SSW"];
    self.strings["SW"] = LANG["kLang.Direction.SW"];
    self.strings["Variable"] = LANG["kLang.Direction.Variable"];
    self.strings["W"] = LANG["kLang.Direction.W"];
    self.strings["West"] = LANG["kLang.Direction.West"];
    self.strings["WNW"] = LANG["kLang.Direction.WNW"];
    self.strings["WSW"] = LANG["kLang.Direction.WSW"];
    
    //Units
    self.strings["Units"] = LANG["kLang.Measurement.Title.Units"];
    self.strings["&deg;F"] = LANG["kLang.Misc.DegreesFSymbol"];
    self.strings["&deg;C"] = LANG["kLang.Misc.DegreesCSymbol"];
    self.strings["Both"] = LANG["kLang.Measurement.BothMetricImperialUnits"];
    self.strings["mph"]    = LANG["kLang.Stats.Misc.MPH"];
    self.strings["kph"]    = LANG["kLang.Stats.Misc.KMH"];
    self.strings["in"]     = LANG["kLang.Measurement.InchesAbbrev"];
    self.strings["hpa"]    = LANG["kLang.Stats.Misc.HPA"];
    self.strings["sm"]    = "sm";
    self.strings["mi"]    = "mi";
    self.strings["km"]    = LANG["kLang.Measurement.Kilometers"];
    self.strings["N/A"]   = "N/A"; //"Not available" abbreviation

    //Text forecast
    self.strings["Today"] = LANG["kLang.DateTime.Today"];
    self.strings["Later"] = LANG["kLang.Widget.Message.Later"];
    self.strings["as of"] = "as of";
    self.strings["more"] = LANG["kLang.Widget.Message.More"];
    
    //Settings text
    self.strings["City, State or ZIP Code"] = LANG["kLang.Widget.Title.CityStateZip"];
    self.strings["Couldn't find city, be more specific"] = LANG["kLang.Widget.Error.CouldNotFind"];
    self.strings["Please check your internet connection"] = LANG["kLang.Widget.Error.Connection"];
    self.strings["Please refine your search"] = LANG["kLang.Widget.Error.Refine"];
    self.strings["Select your local weather station"] = LANG["kLang.Widget.Phrase.SelectWS"];    

    //Upper tab text
    self.strings["Radar"] = LANG["kLang.Widget.Title.Radar"];
    self.strings["Conditions"] = LANG["kLang.Widget.Title.Conditions"];
    self.strings["Cams"] = LANG["kLang.Widget.Title.Cams"];

    //Conditions text
    self.strings["Wind"] = LANG["kLang.Stats.Wind.Wind"].replace(/\s+/g,"&nbsp;");
    self.strings["Windchill"] = LANG["kLang.Stats.Wind.Chill"].replace(/\s+/g,"&nbsp;");
    self.strings["Humidity"] = LANG["kLang.Stats.Misc.Humidity"].replace(/\s+/g,"&nbsp;");
    self.strings["Dew Point"] = LANG["kLang.Misc.DewPoint"].replace(/\s+/g,"&nbsp;");
    self.strings["Pressure"] = LANG["kLang.Stats.Misc.Pressure"].replace(/\s+/g,"&nbsp;");
    self.strings["Visibility"] = LANG["kLang.Stats.Misc.Visibility"].replace(/\s+/g,"&nbsp;");
    self.strings["Heat Index"] = LANG["kLang.Stats.Misc.HeatIndex"].replace(/\s+/g,"&nbsp;");

    //Station selection text
    self.strings["Airports"] = LANG["kLang.Forecast.TableAirport"];
    self.strings["Personal Weather Stations"] = LANG["kLang.Misc.PersonalWeatherStations"];
    self.strings["Select a location"] = LANG["kLang.Widget.Title.SelectALocation"];

    //Buttons on the bottom of the widget
    self.strings["Forecast"] = LANG["kLang.Forecast.WeatherForecast"];
    self.strings["Photos"] = "Photos";

    //Button on the back side
    self.strings["Search"] = LANG["kLang.Misc.Search"];
    self.strings["Done"] = LANG["kLang.Widget.Button.Done"];
    self.strings["Cancel"] = LANG["kLang.WebCam.Button.Cancel"];

    //Upgrade dialog
    self.strings["Click here or visit wunderground.com to upgrade!"] = LANG["kLang.Widget.Link.Upgrade"];
    self.strings["This widget version is"] = LANG["kLang.Widget.Phrase.WidgetVersion"];
    self.strings["The latest widget version is"] = LANG["kLang.Widget.Phrase.LatestVersion"];
    self.strings["New version"] = LANG["kLang.Widget.Title.NewVersion"];

    //Photo feed selection
    self.strings["photoFeed"] = LANG["kLang.Widget.Phrase.PhotoFeed"];
    self.strings["Loading"] = LANG["kLang.Widget.Message.Loading"];

    //Alerts
    self.strings["Current Warnings"] = LANG["kLang.Warning.Title.CurrentWarnings"];
    self.strings["Dense Fog Advisory"] = LANG["kLang.Warning.Title.DenseFog"];
    self.strings["Fire Weather Advisory"] = LANG["kLang.Warning.Title.FireWeather"];
    self.strings["Flood Warning"] = LANG["kLang.Warning.Title.FloodWarning"];
    self.strings["Flood Watch \x2F Statement"] = LANG["kLang.Warning.Title.FloodWatch"];
    self.strings["Heat Advisory"] = LANG["kLang.Warning.Title.HeatAdvisory"];
    self.strings["High Wind Advisory"] = LANG["kLang.Warning.Title.HighWind"];
    self.strings["Hurricane Local Statement"] = LANG["kLang.Warning.Title.HurricaneLocal"];
    self.strings["Public Statement"] = LANG["kLang.Warning.Title.PublicStatement"];
    self.strings["Severe Weather Forecasts"] = LANG["kLang.Warning.Title.SevereForecasts"];
    self.strings["Severe Weather Maps and FAQs"] = LANG["kLang.Warning.Title.SevereMapsFAQs"];
    self.strings["Special Weather Statement\x3Cbr\x3EPublic Notice\x3Cbr\x3EPublic Record\x3Cbr\x3EPublic Statement"] = LANG["kLang.Warning.Title.SpecialStatement"];
    self.strings["Severe Thunderstorm Warning"] = LANG["kLang.Warning.Title.ThunderstormWarning"];
    self.strings["Severe Thunderstorm Watch"] = LANG["kLang.Warning.Title.ThunderstormWatch"];
    self.strings["Tornado Warning"] = LANG["kLang.Warning.Title.TornadoWarning"];
    self.strings["Tornado Watch"] = LANG["kLang.Warning.Title.TornadoWatch"];
    self.strings["Volcanic Ash Advisory"] = LANG["kLang.Warning.Title.VolcanicAsh"];
    self.strings["Weather Warning Legend"] = LANG["kLang.Warning.Title.WarningLegend"];
    self.strings["Warnings and Notices"] = LANG["kLang.Warning.Title.WarningNotice"];
    self.strings["Warnings by County"] = LANG["kLang.Warning.Title.WarningsByCounty"];
    self.strings["Special Weather Statement"] = LANG["kLang.Warning.Title.WeatherStatement"];
    self.strings["Winter Weather Statement"] = LANG["kLang.Warning.Title.WinterWeather"];
    self.strings["Tropical Weather"] = LANG["kLang.Warning.TropicalWeather"];
    
    //Conditions
    self.strings["Heavy Blowing Sand"] = LANG["kLang.Conditions.Heavy.BlowingSand"];
    self.strings["Heavy Blowing Snow"] = LANG["kLang.Conditions.Heavy.BlowingSnow"];
    self.strings["Heavy Blowing Widespread Dust"] = LANG["kLang.Conditions.Heavy.BlowingWidespreadDust"];
    self.strings["Heavy Drizzle"] = LANG["kLang.Conditions.Heavy.Drizzle"];
    self.strings["Heavy Dust Whirls"] = LANG["kLang.Conditions.Heavy.DustWhirls"];
    self.strings["Heavy Fog"] = LANG["kLang.Conditions.Heavy.Fog"];
    self.strings["Heavy Freezing Drizzle"] = LANG["kLang.Conditions.Heavy.FreezingDrizzle"];
    self.strings["Heavy Freezing Fog"] = LANG["kLang.Conditions.Heavy.FreezingFog"];
    self.strings["Heavy Freezing Rain"] = LANG["kLang.Conditions.Heavy.FreezingRain"];
    self.strings["Heavy Hail"] = LANG["kLang.Conditions.Heavy.Hail"];
    self.strings["Heavy Haze"] = LANG["kLang.Conditions.Heavy.Haze"];
    self.strings["Heavy Ice Crystals"] = LANG["kLang.Conditions.Heavy.IceCrystals"];
    self.strings["Heavy Ice Pellets"] = LANG["kLang.Conditions.Heavy.IcePellets"];
    self.strings["Heavy Low Drifting Sand"] = LANG["kLang.Conditions.Heavy.LowDriftingSand"];
    self.strings["Heavy Low Drifting Snow"] = LANG["kLang.Conditions.Heavy.LowDriftingSnow"];
    self.strings["Heavy Mist"] = LANG["kLang.Conditions.Heavy.Mist"];
    self.strings["Heavy Fog Patches"] = LANG["kLang.Conditions.Heavy.PatchesFog"];
    self.strings["Heavy Rain"] = LANG["kLang.Conditions.Heavy.Rain"];
    self.strings["Heavy Sand"] = LANG["kLang.Conditions.Heavy.Sand"];
    self.strings["Heavy Sandstorm"] = LANG["kLang.Conditions.Heavy.Sandstorm"];
    self.strings["Heavy Hail Showers"] = LANG["kLang.Conditions.Heavy.ShowersHail"];
    self.strings["Heavy Rain Showers"] = LANG["kLang.Conditions.Heavy.ShowersRain"];
    self.strings["Heavy Snow Showers"] = LANG["kLang.Conditions.Heavy.ShowersSnow"];
    self.strings["Heavy Small Hail"] = LANG["kLang.Conditions.Heavy.SmallHail"];
    self.strings["Heavy Smoke"] = LANG["kLang.Conditions.Heavy.Smoke"];
    self.strings["Heavy Snow"] = LANG["kLang.Conditions.Heavy.Snow"];
    self.strings["Heavy Snow Grains"] = LANG["kLang.Conditions.Heavy.SnowGrains"];
    self.strings["Heavy Spray"] = LANG["kLang.Conditions.Heavy.Spray"];
    self.strings["Heavy Thunderstorm"] = LANG["kLang.Conditions.Heavy.Thunderstorm"];
    self.strings["Heavy Thunderstorms With Hail"] = LANG["kLang.Conditions.Heavy.ThunderstormHail"];
    self.strings["Heavy Thunderstorms With Ice Pellets"] = LANG["kLang.Conditions.Heavy.ThunderstormIcePellets"];
    self.strings["Heavy Thunderstorms And Rain"] = LANG["kLang.Conditions.Heavy.ThunderstormRain"];
    self.strings["Heavy Thunderstorms With Small Hail"] = LANG["kLang.Conditions.Heavy.ThunderstormSmallHail"];
    self.strings["Heavy Thunderstorms And Snow"] = LANG["kLang.Conditions.Heavy.ThunderstormSnow"];
    self.strings["Heavy Volcanic Ash"] = LANG["kLang.Conditions.Heavy.VolcanicAsh"];
    self.strings["Heavy Widespread Dust"] = LANG["kLang.Conditions.Heavy.WidespreadDust"];
    self.strings["Light Blowing Sand"] = LANG["kLang.Conditions.Light.BlowingSand"];
    self.strings["Light Blowing Snow"] = LANG["kLang.Conditions.Light.BlowingSnow"];
    self.strings["Light Blowing Widespread Dust"] = LANG["kLang.Conditions.Light.BlowingWidespreadDust"];
    self.strings["Light Drizzle"] = LANG["kLang.Conditions.Light.Drizzle"];
    self.strings["Light Dust Whirls"] = LANG["kLang.Conditions.Light.DustWhirls"];
    self.strings["Light Fog"] = LANG["kLang.Conditions.Light.Fog"];
    self.strings["Light Hail"] = LANG["kLang.Conditions.Light.Hail"];
    self.strings["Light Haze"] = LANG["kLang.Conditions.Light.Haze"];
    self.strings["Light Ice Crystals"] = LANG["kLang.Conditions.Light.IceCrystals"];
    self.strings["Light Ice Pellets"] = LANG["kLang.Conditions.Light.IcePellets"];
    self.strings["Light Low Drifting Sand"] = LANG["kLang.Conditions.Light.LowDriftingSand"];
    self.strings["Light Low Drifting Snow"] = LANG["kLang.Conditions.Light.LowDriftingSnow"];
    self.strings["Light Low Drifting Widespread Dust"] = LANG["kLang.Conditions.Light.LowDriftingWidespreadDust"];
    self.strings["Light Mist"] = LANG["kLang.Conditions.Light.Mist"];
    self.strings["Light Rain"] = LANG["kLang.Conditions.Light.Rain"];
    self.strings["Light Sand"] = LANG["kLang.Conditions.Light.Sand"];
    self.strings["Light Sandstorm"] = LANG["kLang.Conditions.Light.Sandstorm"];
    self.strings["Light Hail Showers"] = LANG["kLang.Conditions.Light.ShowersHail"];
    self.strings["Light Ice Pellet Showers"] = LANG["kLang.Conditions.Light.ShowersIcePellets"];
    self.strings["Light Rain Showers"] = LANG["kLang.Conditions.Light.ShowersRain"];
    self.strings["Light Small Hail Showers"] = LANG["kLang.Conditions.Light.ShowersSmallHail"];
    self.strings["Light Snow Showers"] = LANG["kLang.Conditions.Light.ShowersSnow"];
    self.strings["Light Smoke"] = LANG["kLang.Conditions.Light.Smoke"];
    self.strings["Light Snow"] = LANG["kLang.Conditions.Light.Snow"];
    self.strings["Light Snow Grains"] = LANG["kLang.Conditions.Light.SnowGrains"];
    self.strings["Light Spray"] = LANG["kLang.Conditions.Light.Spray"];
    self.strings["Light Thunderstorm"] = LANG["kLang.Conditions.Light.Thunderstorm"];
    self.strings["Light Thunderstorms With Hail"] = LANG["kLang.Conditions.Light.ThunderstormHail"];
    self.strings["Light Thunderstorms And Ice Pellets"] = LANG["kLang.Conditions.Light.ThunderstormIcePellets"];
    self.strings["Light Thunderstorms And Rain"] = LANG["kLang.Conditions.Light.ThunderstormRain"];
    self.strings["Light Thunderstorms With Small Hail"] = LANG["kLang.Conditions.Light.ThunderstormSmallHail"];
    self.strings["Light Thunderstorms And Snow"] = LANG["kLang.Conditions.Light.ThunderstormSnow"];
    self.strings["Light Volcanic Ash"] = LANG["kLang.Conditions.Light.VolcanicAsh"];
    self.strings["Light Widespread Dust"] = LANG["kLang.Conditions.Light.WidespreadDust"];
    self.strings["Snow Depth"] = LANG["kLang.Conditions.LinkTitles.SnowDepth"];
    self.strings["Blowing Sand"] = LANG["kLang.Conditions.Normal.BlowingSand"];
    self.strings["Blowing Snow"] = LANG["kLang.Conditions.Normal.BlowingSnow"];
    self.strings["Calm"] = LANG["kLang.Conditions.Normal.Calm"];
    self.strings["Chance Of Freezing Rain"] = LANG["kLang.Conditions.Normal.ChanceFreezingRain"];
    self.strings["chance Of precipitation"] = LANG["kLang.Conditions.Normal.ChancePrecipitation"];
    self.strings["Chance Of Rain"] = LANG["kLang.Conditions.Normal.ChanceRain"];
    self.strings["Chance Of Snow"] = LANG["kLang.Conditions.Normal.ChanceSnow"];
    self.strings["Chance Of A Thunderstorm"] = LANG["kLang.Conditions.Normal.ChanceThunderstorm"];
    self.strings["Clear"] = LANG["kLang.Conditions.Normal.Clear"];
    self.strings["Clouds"] = LANG["kLang.Conditions.Normal.Clouds"];
    self.strings["Drizzle"] = LANG["kLang.Conditions.Normal.Drizzle"];
    self.strings["Dust Whirls"] = LANG["kLang.Conditions.Normal.DustWhirls"];
    self.strings["Fog"] = LANG["kLang.Conditions.Normal.Fog"];
    self.strings["Light Freezing Drizzle"] = LANG["kLang.Conditions.Normal.FreezingDrizzle"];
    self.strings["Light Freezing Fog"] = LANG["kLang.Conditions.Normal.FreezingFog"];
    self.strings["Light Freezing Rain"] = LANG["kLang.Conditions.Normal.FreezingRain"];
    self.strings["Funnel Cloud"] = LANG["kLang.Conditions.Normal.FunnelCloud"];
    self.strings["Hail"] = LANG["kLang.Conditions.Normal.Hail"];
    self.strings["Haze"] = LANG["kLang.Conditions.Normal.Haze"];
    self.strings["Ice Crystals"] = LANG["kLang.Conditions.Normal.IceCrystals"];
    self.strings["Ice Pellets"] = LANG["kLang.Conditions.Normal.IcePellets"];
    self.strings["Low Drifting Sand"] = LANG["kLang.Conditions.Normal.LowDriftingSand"];
    self.strings["Low Drifting Snow"] = LANG["kLang.Conditions.Normal.LowDriftingSnow"];
    self.strings["Low Drifting Widespread Dust"] = LANG["kLang.Conditions.Normal.LowDriftingWidespreadDust"];
    self.strings["Mist"] = LANG["kLang.Conditions.Normal.Mist"];
    self.strings["Mostly Cloudy"] = LANG["kLang.Conditions.Normal.MostlyCloudy"];
    self.strings["Overcast"] = LANG["kLang.Conditions.Normal.Overcast"];
    self.strings["Partial Fog"] = LANG["kLang.Conditions.Normal.PartialFog"];
    self.strings["Partly Cloudy"] = LANG["kLang.Conditions.Normal.PartlyCloudy"];
    self.strings["Patches Of Fog"] = LANG["kLang.Conditions.Normal.PatchesFog"];
    self.strings["Rain"] = LANG["kLang.Conditions.Normal.Rain"];
    self.strings["Sand"] = LANG["kLang.Conditions.Normal.Sand"];
    self.strings["Sandstorm"] = LANG["kLang.Conditions.Normal.Sandstorm"];
    self.strings["Scattered Clouds"] = LANG["kLang.Conditions.Normal.ScatteredClouds"];
    self.strings["Shallow Fog"] = LANG["kLang.Conditions.Normal.ShallowFog"];
    self.strings["Hail Showers"] = LANG["kLang.Conditions.Normal.ShowersHail"];
    self.strings["Ice Pellet Showers"] = LANG["kLang.Conditions.Normal.ShowersIcePellets"];
    self.strings["Rain Showers"] = LANG["kLang.Conditions.Normal.ShowersRain"];
    self.strings["Small Hail Showers"] = LANG["kLang.Conditions.Normal.ShowersSmallHail"];
    self.strings["Snow Showers"] = LANG["kLang.Conditions.Normal.ShowersSnow"];
    self.strings["Small Hail"] = LANG["kLang.Conditions.Normal.SmallHail"];
    self.strings["Smoke"] = LANG["kLang.Conditions.Normal.Smoke"];
    self.strings["Snow"] = LANG["kLang.Conditions.Normal.Snow"];
    self.strings["Snow Grains"] = LANG["kLang.Conditions.Normal.SnowGrains"];
    self.strings["Spray"] = LANG["kLang.Conditions.Normal.Spray"];
    self.strings["Squalls"] = LANG["kLang.Conditions.Normal.Squalls"];
    self.strings["Thunderstorm"] = LANG["kLang.Conditions.Normal.Thunderstorm"];
    self.strings["Thunderstorms With Hail"] = LANG["kLang.Conditions.Normal.ThunderstormHail"];
    self.strings["Thunderstorms And Ice Pellets"] = LANG["kLang.Conditions.Normal.ThunderstormIcePellets"];
    self.strings["Thunderstorms And Rain"] = LANG["kLang.Conditions.Normal.ThunderstormRain"];
    self.strings["Thunderstorms With Small Hail"] = LANG["kLang.Conditions.Normal.ThunderstormSmallHail"];
    self.strings["Thunderstorms And Snow"] = LANG["kLang.Conditions.Normal.ThunderstormSnow"];
    self.strings["Unknown"] = LANG["kLang.Conditions.Normal.Unknown"];
    self.strings["Unknown Precipitation"] = LANG["kLang.Conditions.Normal.UnknownPrecipitation"];
    self.strings["Volcanic Ash"] = LANG["kLang.Conditions.Normal.VolcanicAsh"];
    self.strings["Widespread Dust"] = LANG["kLang.Conditions.Normal.WidespreadDust"];
    //Sets the units
    // Units_update();

    //Sets the forecast day strings
    if (Forecast_forecastData) Gadget_launchLocalStns(Forecast_forecastData);
    
    $('connectionProblemLabel').innerHTML = getLocalizedString("Please check your internet connection");

  };

}